import { defineComponent as L, computed as w, openBlock as b, createElementBlock as x, normalizeClass as C, createElementVNode as r, toDisplayString as O, reactive as $, shallowRef as _, onMounted as E, Fragment as M, renderList as S, createVNode as N, TransitionGroup as D, withCtx as A, createBlock as U, resolveDynamicComponent as V } from "vue";
function F(t) {
  return t = t || /* @__PURE__ */ new Map(), {
    /**
     * A Map of event names to registered handler functions.
     */
    all: t,
    /**
     * Register an event handler for the given type.
     * @param {string|symbol} type Type of event to listen for, or `'*'` for all events
     * @param {Function} handler Function to call in response to given event
     * @memberOf mitt
     */
    on(s, e) {
      const o = t.get(s);
      o ? o.push(e) : t.set(s, [e]);
    },
    /**
     * Remove an event handler for the given type.
     * If `handler` is omitted, all handlers of the given type are removed.
     * @param {string|symbol} type Type of event to unregister `handler` from (`'*'` to remove a wildcard handler)
     * @param {Function} [handler] Handler function to remove
     * @memberOf mitt
     */
    off(s, e) {
      const o = t.get(s);
      o && (e ? o.splice(o.indexOf(e) >>> 0, 1) : t.set(s, []));
    },
    /**
     * Invoke all handlers for the given type.
     * If present, `'*'` handlers are invoked after type-matched handlers.
     *
     * Note: Manually firing '*' handlers is not supported.
     *
     * @param {string|symbol} type The event type to invoke
     * @param {Any} [evt] Any value (object is recommended and powerful), passed to each handler
     * @memberOf mitt
     */
    emit(s, e) {
      let o = t.get(s);
      o && o.slice().map((u) => {
        u(e);
      }), o = t.get("*"), o && o.slice().map((u) => {
        u(s, e);
      });
    }
  };
}
const P = F(), z = Object.freeze({
  showToast: "show-toast"
}), R = Object.freeze(["top-right", "bottom-right", "top-left", "bottom-left", "top", "bottom"]), G = () => {
  const t = new Uint32Array(1);
  return window.crypto.getRandomValues(t), t[0].toString().padStart(10, "0");
}, K = async (t) => {
  const s = {
    ...t,
    id: G(),
    group: t.group || "top",
    alertType: t.alertType || "info",
    sticky: t.sticky || !1
  };
  P.emit(z.showToast, s);
}, q = () => ({
  showToast: K,
  toastPositions: R
}), a = /* @__PURE__ */ new Map();
a.set("info", "bg-info text-info-content");
a.set("success", "bg-success text-success-content");
a.set("warning", "bg-warning text-warning-content");
a.set("danger", "bg-danger text-danger-content");
a.set("primary", "bg-primary text-info-primary");
a.set("secondary", "bg-secondary text-secondary-content");
a.set("accent", "bg-accent text-accent-content");
a.set("neutral", "bg-neutral text-neutral-content");
a.set("body", "bg-body text-body-content");
a.set("card", "bg-card text-card-content");
a.set("code", "bg-code text-code-content");
const i = /* @__PURE__ */ new Map();
i.set("info", "text-info-content");
i.set("success", "text-success-content");
i.set("warning", "text-warning-content");
i.set("danger", "text-danger-content");
i.set("primary", "text-primary-content");
i.set("secondary", "text-secondary-content");
i.set("accent", "text-accent-content");
i.set("neutral", "text-neutral-content");
i.set("body", "bg-body text-body-content");
i.set("card", "bg-card text-card-content");
i.set("code", "bg-code text-code-content");
const l = /* @__PURE__ */ new Map();
l.set("info", "text-info-content");
l.set("success", "text-success-content");
l.set("warning", "text-warning-content");
l.set("danger", "text-danger-content");
l.set("primary", "text-primary-content");
l.set("secondary", "text-secondary-content");
l.set("accent", "text-accent-content");
l.set("neutral", "text-neutral-content");
l.set("body", "bg-body text-body-content");
l.set("card", "bg-card text-card-content");
l.set("code", "bg-code text-code-content");
const d = /* @__PURE__ */ new Map();
d.set("info", "bg-info text-info-content hover:bg-info-hover focus:ring-info-focus");
d.set(
  "success",
  "bg-success text-success-content hover:bg-success-hover ffocus:ring-success-focus"
);
d.set("warning", "bg-warning text-warning-content hover:bg-warning-hover focus:ring-warning-focus");
d.set("danger", "bg-danger text-danger-content hover:bg-danger-hover focus:ring-danger-focus");
d.set("primary", "bg-primary text-primary-content hover:bg-primary-hover focus:ring-primary-focus");
d.set(
  "secondary",
  "bg-secondary text-secondary-content hover:bg-secondary-hover ffocus:ring-secondary-focus"
);
d.set("accent", "bg-accent text-accent-content hover:bg-accent-hover focus:ring-accent-focus");
d.set("neutral", "bg-neutral text-neutral-content hover:bg-neutral-hover focus:ring-neutral-focus");
d.set("body", "bg-body text-body-content hover:bg-body-400 focus:ring-body-300");
d.set("card", "bg-card text-card-content hover:bg-card-400 focus:ring-card-300");
d.set("code", "bg-code text-code-content hover:bg-code-400 focus:ring-code-300");
const H = { class: "flex" }, J = { class: "flex-shrink-0" }, Q = /* @__PURE__ */ r("path", {
  "fill-rule": "evenodd",
  d: "M10 18a8 8 0 100-16 8 8 0 000 16zm3.707-9.293a1 1 0 00-1.414-1.414L9 10.586 7.707 9.293a1 1 0 00-1.414 1.414l2 2a1 1 0 001.414 0l4-4z",
  "clip-rule": "evenodd"
}, null, -1), W = [
  Q
], X = { class: "ml-3" }, Y = { class: "ml-auto pl-3" }, Z = { class: "-mx-1.5 -my-1.5" }, tt = /* @__PURE__ */ r("span", { class: "sr-only" }, "Dismiss", -1), et = /* @__PURE__ */ r("svg", {
  class: "h-5 w-5",
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 20 20",
  fill: "currentColor",
  "aria-hidden": "true"
}, [
  /* @__PURE__ */ r("path", {
    "fill-rule": "evenodd",
    d: "M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10 11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z",
    "clip-rule": "evenodd"
  })
], -1), st = [
  tt,
  et
], B = /* @__PURE__ */ L({
  __name: "ElAlertPanel",
  props: {
    testid: { default: "not-set" },
    id: { default: "not-set" },
    alertType: { default: "info" },
    message: { default: "not-set" },
    addCss: {}
  },
  emits: ["close"],
  setup(t, { emit: s }) {
    const e = t, o = s, u = w(() => {
      const n = ["rounded-md p-4 h-fit shadow shadow-md"];
      n.push(a.get(e.alertType));
      const v = (e.addCss || "").trim();
      return v.length > 0 && n.push(v), n.join(" ").trim();
    }), T = w(() => {
      const n = ["text-sm font-medium"];
      return n.push(l.get(e.alertType)), n.join(" ").trim();
    }), m = w(() => {
      const n = ["h-5 w-5"];
      return n.push(i.get(e.alertType)), n.join(" ").trim();
    }), k = w(() => {
      const n = ["cursor-pointer inline-flex rounded-md p-1.5 focus:outline-none focus:ring-2 focus:ring-offset-2"];
      return n.push(d.get(e.alertType)), n.join(" ").trim();
    }), j = () => {
      o("close", e.id);
    };
    return (n, v) => (b(), x("div", {
      class: C(u.value)
    }, [
      r("div", H, [
        r("div", J, [
          (b(), x("svg", {
            class: C(m.value),
            xmlns: "http://www.w3.org/2000/svg",
            viewBox: "0 0 20 20",
            fill: "currentColor",
            "aria-hidden": "true"
          }, W, 2))
        ]),
        r("div", X, [
          r("p", {
            class: C(T.value)
          }, O(e.message), 3)
        ]),
        r("div", Y, [
          r("div", Z, [
            r("button", {
              type: "button",
              class: C(k.value),
              onClick: j
            }, st, 2)
          ])
        ])
      ])
    ], 2));
  }
}), ot = {
  id: "toast-portal",
  class: "pointer-events-none"
}, nt = { class: "w-full max-w-sm" }, ct = 3e3, rt = "fixed flex p-4 pointer-events-none", at = /* @__PURE__ */ L({
  __name: "ToastPortal",
  props: {
    testid: { default: "not-set" },
    maxItems: { default: 5 },
    toastComponent: {}
  },
  emits: ["close"],
  setup(t, { emit: s }) {
    let e = 0;
    const o = /* @__PURE__ */ new Map([
      ["top-right", "top-0 right-0 justify-end"],
      ["bottom-right", "bottom-0 right-0 justify-end"],
      ["top-left", "top-0 left-0"],
      ["bottom-left", "bottom-0 left-0"],
      ["top", "w-full top-0 justify-center"],
      ["bottom", "w-full bottom-0 justify-center"]
    ]), u = t, T = s, m = $({
      items: [],
      defaultToastComponent: u.toastComponent ? _(u.toastComponent) : _(B),
      currentToastComponent: u.toastComponent ? _(u.toastComponent) : _(B)
    }), k = w(() => {
      const c = m.items || [], { maxItems: f } = u;
      return [.../* @__PURE__ */ new Set([...c.map((y) => y.group || "top")])].map((y) => {
        let h = c.filter((I) => I.group === y);
        return y.indexOf("bottom") > -1 ? h = h.slice(0, f) : h = h.reverse().slice(0, f), {
          id: y,
          cssClass: `${rt} ${o.get(y) || ""}`,
          items: h
        };
      });
    }), j = (c) => {
      const { toastComponent: f, sticky: p } = c;
      f ? m.currentToastComponent = f : m.currentToastComponent = m.defaultToastComponent;
      const g = c.group || "";
      (g == null ? void 0 : g.indexOf("top")) > -1 ? m.items.push(c) : m.items.unshift(c);
      const { timeout: y } = c, h = Number(Number(y || ct) + e);
      p || (setTimeout(() => {
        n(c.id);
      }, h), e += 75);
    }, n = (c) => {
      const f = m.items || [], p = f.findIndex((g) => g.id === c);
      p > -1 && f.splice(p, 1);
    }, v = (c) => {
      T("close", c), n(c);
    };
    return E(() => {
      P.on(z.showToast, j);
    }), (c, f) => (b(), x("div", ot, [
      (b(!0), x(M, null, S(k.value, (p) => (b(), x("div", {
        key: p.id
      }, [
        r("div", {
          class: C(p.cssClass)
        }, [
          r("div", nt, [
            N(D, {
              "enter-active-class": "transform ease-out duration-300 transition",
              "enter-from-class": "translate-y-2 opacity-0 sm:translate-y-0 sm:translate-x-4",
              "enter-to-class": "translate-y-0 opacity-100 sm:translate-x-0",
              "leave-active-class": "transition ease-in duration-500",
              "leave-from-class": "opacity-100",
              "leave-to-class": "transform opacity-0",
              "move-class": "transition duration-500"
            }, {
              default: A(() => [
                (b(!0), x(M, null, S(p.items, (g) => (b(), x("div", {
                  key: g.id
                }, [
                  (b(), U(V(m.currentToastComponent), {
                    id: g.id,
                    addCss: "mt-2 pointer-events-auto shadow-black shadow-md",
                    alertType: g.alertType,
                    message: g.message,
                    onClose: v
                  }, null, 40, ["id", "alertType", "message"]))
                ]))), 128))
              ]),
              _: 2
            }, 1024)
          ])
        ], 2)
      ]))), 128))
    ]));
  }
}), lt = {
  install(t) {
    const { showToast: s } = q();
    t.config.globalProperties.$showToast = s, t.component("ToastPortal", at);
  }
};
export {
  lt as ToastPlugin,
  q as useToast
};
